// 
// udp_writer.cc : Sends data to a remote udp socket
// authors       : Fabio Silva, John Heidemann
//
// Copyright (C) 2000-2002 by the University of Southern California
// $Id: udp_writer.cc,v 1.2 2002/08/29 01:38:44 fabio Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>

#include <iostream.h>

#define BUFFER_SIZE 512

void writer(int port, char *host)
{
  struct hostent *host_ent = NULL;
  int fd;
  struct sockaddr_in skt_addr_inet;
  int inc, outc;
  char buf[BUFFER_SIZE];

  host_ent = gethostbyname(host);
  if (!host_ent){
    printf("Can't resolve host name !\n");
    exit(1);
  }

  fd = socket(AF_INET, SOCK_DGRAM, 0);
  if (fd < 0){
    printf("Cannot create socket !\n");
    exit(1);
  }

  bzero((char *) &skt_addr_inet, sizeof(skt_addr_inet));

  skt_addr_inet.sin_family = AF_INET;
  skt_addr_inet.sin_port = htons(port);
  bcopy(host_ent->h_addr, (char *) &(skt_addr_inet.sin_addr),
	host_ent->h_length);

  while(1){
    cin.getline(buf, BUFFER_SIZE - 1);

    if (cin.eof()){
      cin.clear();
      return;
    }

    inc = strlen(buf);

    buf[inc] = '\n';
    buf[inc+1] = 0;

    outc = sendto(fd, buf, inc + 1, 0,
		  (struct sockaddr *) &(skt_addr_inet),
		  sizeof(skt_addr_inet));
  }
}

main(int argc, char **argv)
{
  int port = 0;
  int c;

  while ((c = getopt(argc, argv, "p:")) != -1)
    switch (c){
    case 'p':
      port = atoi(optarg);
      break;
    }
  if (optind >= argc || port == 0){
    printf("usage: %s -p port destination\n", argv[0]);
    exit(1);
  }

  writer(port, argv[optind]);
}
